/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : july 1995/july 1996
 *
 *  Purpose    : mini database
 *
 *  Modified   : august 1996
 *               various small fixes
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "cgilib.h"

int check_access();

main(int argc,char *argv[])
{
   FILE *fpcf;
   int n;
   char *cf,db[256],title[81],fld[81],*p;
   cgi_init(argc,argv);
   cf=cgi_info("PATH_INFO");
   cf++;
   cgi_printf("content-type: text/html\n\n");
   if(strcmp(cgi_info("REQUEST_METHOD"),"HEAD")==0) exit(1);
   /* open control-file */
   if(!check_access(cf)) {
      cgi_printf("No access to file: %s\n",cf);
      goto fin;
   }
   fpcf=fopen(cf,"r");
   if(fpcf==NULL) {
       cgi_printf("Can not open file: %s\n",cf);
       goto fin;
   }
   /* read control-file hreader and write HTML header */
   fgets(db,sizeof(db),fpcf);
   db[strlen(db)-1]='\0';
   fgets(title,sizeof(title),fpcf);
   title[strlen(title)-1]='\0';
   /* start HTML */
   cgi_printf("<HTML>\n");
   cgi_printf("<HEAD>\n");
   cgi_printf("<TITLE>%s</TITLE>\n",title);
   cgi_printf("</HEAD>\n");
   cgi_printf("<BODY>\n");
   cgi_printf("<H1>%s</H1>\n",title);
   /* create form */
   cgi_printf("<FORM METHOD=\"POST\" ACTION=\"/htbin/minidb5.exe/%s\">\n",cf);
   cgi_printf("<PRE>\n");
   n=0;
   while(!feof(fpcf)) {
      if(fgets(fld,sizeof(fld),fpcf)!=NULL) {
         fld[strlen(fld)-1]='\0';
         if(strlen(fld)>0) {
            n++;
            cgi_printf("%s?\n<INPUT TYPE=\"TEXT\" SIZE=60 NAME=\"fld%d\">\n",
                       fld,n);
         }
      }
   }
   cgi_printf("</PRE>\n");
   cgi_printf("<INPUT TYPE=\"SUBMIT\" VALUE=\"Press return to submit\">\n");
   cgi_printf("</FORM>\n");
   cgi_printf("<P>\n");
   cgi_printf("(control-file: %s)\n",cf);
   fclose(fpcf);
fin:
   cgi_printf("</BODY>\n");
   cgi_printf("</HTML>\n");
}
